
proc split_ftn_addr {ftnaddr} {
# puts $ftnaddr
 set a 0
 set b 0
 set c 0
 set d 0
 catch {
 regexp {^([0-9]{1,20}):([0-9]{1,20})/([0-9]{1,20})\.([0-9]{1,20})$} $ftnaddr xep a b c d
 } nomatter
 return [list $a $b $c $d]
}

proc zone {f} {
 return [lindex [split_ftn_addr $f] 0]
}
proc net {f} {
 return [lindex [split_ftn_addr $f] 1]
}

proc node {f} {
 return [lindex [split_ftn_addr $f] 2]
}

proc point {f} {
 return [lindex [split_ftn_addr $f] 3]
}

#puts [split_ftn_addr "2:5020/730.1"]